// dbsocketclientView.cpp : implementation of the CDbsocketclientView class
//
// sample code for MIS-495 at The University of Mississippi
// copyright 2002 Brian J. Reithel, Ph.D., CDP
//

#include "stdafx.h"
#include "dbsocketclient.h"

#include "dbsocketclientDoc.h"
#include "dbsocketclientView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "ServerAddressDlg.h"
#include "PartInfoDlg.h"
#include "NotConnectedDlg.h"
#include "PartIDDlg.h"
#include "PartNotFoundDlg.h"
#include "DeletePartIDDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CDbsocketclientView

IMPLEMENT_DYNCREATE(CDbsocketclientView, CView)

BEGIN_MESSAGE_MAP(CDbsocketclientView, CView)
	//{{AFX_MSG_MAP(CDbsocketclientView)
	ON_COMMAND(ID_PARTS_CONNECTTOSERVER, OnPartsConnecttoserver)
	ON_COMMAND(ID_PARTS_DISCONNECTFROMSERVER, OnPartsDisconnectfromserver)
	ON_COMMAND(ID_PARTS_ADDAPART, OnPartsAddapart)
	ON_COMMAND(ID_PARTS_MODIFYAPART, OnPartsModifyapart)
	ON_COMMAND(ID_PARTS_DELETEAPART, OnPartsDeleteapart)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDbsocketclientView construction/destruction

CDbsocketclientView::CDbsocketclientView()
{
	// TODO: add construction code here

}

CDbsocketclientView::~CDbsocketclientView()
{
}

BOOL CDbsocketclientView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDbsocketclientView drawing

void CDbsocketclientView::OnDraw(CDC* pDC)
{
	CDbsocketclientDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDbsocketclientView printing

BOOL CDbsocketclientView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDbsocketclientView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDbsocketclientView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDbsocketclientView diagnostics

#ifdef _DEBUG
void CDbsocketclientView::AssertValid() const
{
	CView::AssertValid();
}

void CDbsocketclientView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDbsocketclientDoc* CDbsocketclientView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDbsocketclientDoc)));
	return (CDbsocketclientDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDbsocketclientView message handlers

void CDbsocketclientView::OnPartsConnecttoserver() 
{

	CDbsocketclientDoc* pDoc;
	pDoc=GetDocument();

	pDoc->sockClient.Create( );               // create the SOCKET 
	
	CServerAddressDlg ServerAddrDlg;
	ServerAddrDlg.m_ServerAddress="";
	if(ServerAddrDlg.DoModal()==IDOK) {

		// seek a connection 
		// -- note: this connection remains in the Doc even after 
		//    this message handler ends -- therefore, all other message
		//    handlers can use this same connection.  Each message handler
		//    can have its own "local" csocketfile and carchive temporary
		//    variables that use this pre-existing connection.
		//
		if(pDoc->sockClient.Connect(ServerAddrDlg.m_ServerAddress, 77))
			pDoc->Connected=TRUE;

	}

}


void CDbsocketclientView::OnPartsDisconnectfromserver() 
{
	CDbsocketclientDoc* pDoc;
	pDoc=GetDocument();

	if(pDoc->Connected) {
		// construct a local file object for use in this message handler
		CSocketFile sockfile(&pDoc->sockClient);

		// construct a local archive object to transmit to server
		CArchive arOut(&sockfile, CArchive::store);

		// send the signal value to server to disconnect
		CString SignalValue="<<**QUIT**>>";
		arOut << SignalValue;
		arOut.Flush();
	}
}

void CDbsocketclientView::OnPartsAddapart() 
{
	CDbsocketclientDoc* pDoc;
	pDoc=GetDocument();

	if(pDoc->Connected) {
		// construct a local file object for use in this message handler
		CSocketFile sockfile(&pDoc->sockClient);

		// construct a local archive object to transmit to server
		CArchive arOut(&sockfile, CArchive::store);

		// create and display the Add Part dialog box
		CPartInfoDlg onePart;
		onePart.m_PartID="";
		onePart.m_PartDesc="";
		if(onePart.DoModal()==IDOK) {
			// send the signal value to server to add a new part
			// then send it the data entered by the user for the new part
			CString SignalValue="<<**ADD**>>";
			arOut << SignalValue;
			arOut << onePart.m_PartID;
			arOut << onePart.m_PartDesc;
			arOut.Flush();
		}
	} else {
		CNotConnectedDlg oneNot;
		oneNot.DoModal();
	}
	
}

void CDbsocketclientView::OnPartsModifyapart() 
{
	CDbsocketclientDoc* pDoc;
	pDoc=GetDocument();

	if(pDoc->Connected) {
		// construct a local file object for use in this message handler
		CSocketFile sockfile(&pDoc->sockClient);

		// construct a local archive object to transmit to server
		CArchive arOut(&sockfile, CArchive::store);

		// construct a local archive to receive from server
		CArchive arIn(&sockfile, CArchive::load);

		// create and display the Part ID dialog box
		CPartIDDlg onePartNumDlg;
		onePartNumDlg.m_PartID="";
		if(onePartNumDlg.DoModal()==IDOK) {

			// send the signal value to server to modify an existing part
			// then send it the data entered by the user for the part ID to lookup
			CString SignalValue="<<**MODIFY**>>";
			arOut << SignalValue;
			arOut << onePartNumDlg.m_PartID;
			arOut.Flush();


			// create temporary variables to hold original values from database
			// in case the user hits Cancel on the Part info dialog box
			CString t_PartID;
			CString t_Desc="";
			
			// listen for the server to send back the part ID and description
			arIn >> t_PartID;
						
			// make sure it was found by the server
			if(t_PartID!="<<**NOMATCH**>>") {

				// read part number as it exists in server 
				// (to deal with upper/lower case searches)
				arIn >> t_Desc;
				
				// display for user to edit
				CPartInfoDlg onePartInfoDlg;
				onePartInfoDlg.m_PartID=t_PartID;
				onePartInfoDlg.m_PartDesc=t_Desc;
				if(onePartInfoDlg.DoModal()==IDOK) {

					// send updated info to server
					arOut << onePartInfoDlg.m_PartID;
					arOut << onePartInfoDlg.m_PartDesc;
					arOut.Flush();
				} else {

					// send original info to server
					arOut << t_PartID;
					arOut << t_Desc;
					arOut.Flush();
				}
			} else {

				// display the No Such Part dialog box
				CPartNotFoundDlg oneNotFoundDlg;
				oneNotFoundDlg.DoModal();
			}

		} // endif part num dialog IDOK
	} // endif connected
}

void CDbsocketclientView::OnPartsDeleteapart() 
{
	CDbsocketclientDoc* pDoc;
	pDoc=GetDocument();

	if(pDoc->Connected) {
		// construct a local file object for use in this message handler
		CSocketFile sockfile(&pDoc->sockClient);

		// construct a local archive object to transmit to server
		CArchive arOut(&sockfile, CArchive::store);

		// construct a local archive to receive from server
		CArchive arIn(&sockfile, CArchive::load);

		// create and display the Part ID dialog box
		CDeletePartIDDlg onePartNumDlg;
		onePartNumDlg.m_PartID="";
		if(onePartNumDlg.DoModal()==IDOK) {

			// send the signal value to server to Delete an existing part
			// then send it the data entered by the user for the part ID to lookup
			CString SignalValue="<<**DELETE**>>";
			arOut << SignalValue;
			arOut << onePartNumDlg.m_PartID;
			arOut.Flush();


			// create a temporary variable to hold server response
			// in case the user entered a bad part ID
			CString t_Response="";
			
			// listen for the server to send back the part description
			arIn >> t_Response;
			
			// make sure it was found by the server
			if(t_Response=="<<**NOMATCH**>>") {

				// display the No Such Part dialog box
				CPartNotFoundDlg oneNotFoundDlg;
				oneNotFoundDlg.DoModal();
			}

		} // endif part num dialog IDOK
	} // endif connected
}
