// dbsocketserverView.cpp : implementation of the CDbsocketserverView class
//
// sample code for MIS-495 at The University of Mississippi
// copyright 2002 Brian J. Reithel, Ph.D., CDP
//


#include "stdafx.h"
#include "dbsocketserver.h"

#include "dbsocketserverDoc.h"
#include "dbsocketserverView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDbsocketserverView

IMPLEMENT_DYNCREATE(CDbsocketserverView, CView)

BEGIN_MESSAGE_MAP(CDbsocketserverView, CView)
	//{{AFX_MSG_MAP(CDbsocketserverView)
	ON_COMMAND(ID_SERVER_START, OnServerStart)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDbsocketserverView construction/destruction

CDbsocketserverView::CDbsocketserverView()
{
	// TODO: add construction code here

}

CDbsocketserverView::~CDbsocketserverView()
{
}

BOOL CDbsocketserverView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDbsocketserverView drawing

void CDbsocketserverView::OnDraw(CDC* pDC)
{
	CDbsocketserverDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDbsocketserverView printing

BOOL CDbsocketserverView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDbsocketserverView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDbsocketserverView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDbsocketserverView diagnostics

#ifdef _DEBUG
void CDbsocketserverView::AssertValid() const
{
	CView::AssertValid();
}

void CDbsocketserverView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDbsocketserverDoc* CDbsocketserverView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDbsocketserverDoc)));
	return (CDbsocketserverDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDbsocketserverView message handlers

void CDbsocketserverView::OnServerStart() 
{
	CDbsocketserverDoc* pDoc;
	pDoc=GetDocument();

	// force first open of database to get user to select .MDB file
	pDoc->Parts.Open(CRecordset::dynaset,NULL);
	pDoc->Parts.Close();


	CSocket sockSrvr;        // construct a socket 
 	sockSrvr.Create(77);     // create the SOCKET 
	sockSrvr.Listen( );      // start listening 
	CSocket sockRecv;        // construct a new, empty socket 
	sockSrvr.Accept( sockRecv ); // accept connection
	CSocketFile file(&sockRecv); // construct file object 
 
	// construct two archives
	CArchive arIn(&file, CArchive::load);
	CArchive arOut(&file, CArchive::store);
 
	CString t_TransactionCode="";
	CString t_PartID="";
	CString t_Description="";
	CString t_SQLstatement="";
	CString SignalString="";

	// read first transaction code from client
	arIn >> t_TransactionCode;

	while(t_TransactionCode != "<<**QUIT**>>")
	{
		if(t_TransactionCode=="<<**ADD**>>") {
			
			// add to database
			pDoc->Parts.Open(CRecordset::dynaset,NULL);
			pDoc->Parts.AddNew();
			// read part ID and description from client
			arIn >> pDoc->Parts.m_ItemID;
			arIn >> pDoc->Parts.m_ItemDesc;
			// confirm new row in table
			pDoc->Parts.Update();
			// close the database
			pDoc->Parts.Close();

		}
		else if(t_TransactionCode=="<<**MODIFY**>>") {
		
			// read part ID from client
			arIn >> t_PartID;

			// build an SQL statement using the CString t_PartID as part of the
			//    WHERE clause -- note the use of apostrophes inside the quotes
			//    to build a statement that ultimately looks like the following
			//    example:  Select * from Parts WHERE ItemID='ABC123';
			//    if the user had entered ABC123 for the Part ID in the client
			//    also note that the SQL statement must end with a semicolon
			//    finally note that if the search field were numeric instead of
			//    text, the number would need to be converted using one of the
			//    string handling functions into a CString before being
			//    concatenated into the middle of the sql statement

			t_SQLstatement="SELECT * FROM Parts WHERE [ItemID]='"+t_PartID+"';";

			// open the recordset with the new SQL statement
			pDoc->Parts.Open(CRecordset::dynaset,t_SQLstatement);
			
			if(pDoc->Parts.IsEOF()) {               // if no matching record found
				SignalString="<<**NOMATCH**>>";
				arOut << SignalString;
				arOut.Flush();
			} else {                                // a match was found
				// send part ID and desc to client
				arOut << pDoc->Parts.m_ItemID;
				arOut << pDoc->Parts.m_ItemDesc;
				arOut.Flush();

				// get part ID and desc back from client
				// note: by letting the user send back the part ID
				//       it can be changed
				pDoc->Parts.Edit();
				arIn >> pDoc->Parts.m_ItemID;
				arIn >> pDoc->Parts.m_ItemDesc;
				pDoc->Parts.Update();
			}
			pDoc->Parts.Close();

		}
		else if(t_TransactionCode=="<<**DELETE**>>") {

			// read part ID from client
			arIn >> t_PartID;

			// build an SQL statement using the CString t_PartID as part of the
			//    WHERE clause -- note the use of apostrophes inside the quotes
			//    to build a statement that ultimately looks like the following
			//    example:  Select * from Parts WHERE ItemID='ABC123';
			//    if the user had entered ABC123 for the Part ID in the client
			//    also note that the SQL statement must end with a semicolon
			//    finally note that if the search field were numeric instead of
			//    text, the number would need to be converted using one of the
			//    string handling functions into a CString before being
			//    concatenated into the middle of the sql statement

			t_SQLstatement="SELECT * FROM Parts WHERE [ItemID]='"+t_PartID+"';";

			// open the recordset with the new SQL statement
			pDoc->Parts.Open(CRecordset::dynaset,t_SQLstatement);
			
			if(pDoc->Parts.IsEOF()) {               // if no matching record found
				SignalString="<<**NOMATCH**>>";
				arOut << SignalString;
				arOut.Flush();
			} else {                                // a match was found
				// send deletion confirmation to client
				SignalString="<<**DELETED**>>";
				arOut << SignalString;
				arOut.Flush();

				// delete the record
				pDoc->Parts.Delete();
			}
			pDoc->Parts.Close();

		}  // end else if Delete

		// read next transaction code
		arIn >> t_TransactionCode;

	} // end while loop

}
